'$include "StyleXP.inc"
'50 buttons max at one time - this is ~5kB RAM
Const MaxButtons      = 50
'custom button styles
TYPE EVENT
'do not change
   INT MouseOut
   INT MouseOver
   INT Disabled
   INT Pushed
'end
EndTYPE
TYPE xpStyleColors
'do not change
   EVENT   BodyColor
   EVENT   TextColor
   EVENT   BorderColor
   EVENT   RegionColor
'end
   INT     ColorTransparent
   ISTRING FontFace[20]
   INT     FontSize
   INT     FontWeight
   INT     DefaultRegionColor
ENDTYPE
' memory for each button
TYPE _MYBUTTON
   UINT HWND
   INT ID
   INT W, H
   xpStyleColors Style
   INT State
   STRING text
   POINTER Parent
ENDTYPE
_MYBUTTON MYBUTTON[MaxButtons]
'do not change
Const STATE_MOUSEOUT  = 0
Const STATE_MOUSEOVER = 1
Const STATE_DISABLED  = 2
Const STATE_PUSHED    = 3
'end
Const STATE_DEFAULT   = 256
LastRedrawedButton    = 0x7FFFFFFF
xpPushedButton        = -2
'------------------------------------
WINDOW win[MaxButtons]
Declare import,SetCapture(hwnd:uint),int
Declare import,ReleaseCapture(),int
Declare Import,GetSysColor(index:Int),Int
Declare import,RtlMoveMemory(dest:pointer, source:pointer, length:int),int
Declare xpCreateButton(parent:pointer, L:int, T:int, W:int, H:int, txt:pointer, id:int, winproc:uint, style:pointer, opt State=0:int),int
Declare xpGetFreePlace(),int
Declare xpRedrawButton(id:int, NewState:int)
Declare xpRedrawingLogic(id:int, NewState:int)
Declare xpColorTwo(_color:int, procent:float),int
Declare xpGetButtonIDbyHandle(hwnd:uint),int
Declare xpGetButtonArrayPosByID(id:int),int
Declare xpGetColors(RegionColor:int byref, BorderColor:int byref, pos:int, state:int)
Declare xpSetButtonText(id:int, opt text=Null:pointer, opt pos=-1:int)
Const COLOR_BTNFACE = 15
'___________________________________________________________________________________
Sub xpCreateButton(parent:pointer, L:int, T:int, W:int, H:int, txt:pointer, id:int, winproc:uint, Style:pointer, State:int),int
   SetType Style, xpStyleColors
   INT pos, StyleLen
   POINTER dest
   pos = xpGetFreePlace()
   IF pos < 0 Then Return 0
   'copy the #<xpStyleColors>Style to #<_MYBUTTON>Style[pos]
   StyleLen = Len(MYBUTTON[0].Style)
   Dest = MYBUTTON[pos].Style
   RtlMoveMemory(Dest, Style, StyleLen)
   MYBUTTON[pos].Parent = #<WINDOW>parent
   
   'if the button should be default (blue region color)
   'then replace Region.MouseOut with blue color 
   IF (State & STATE_DEFAULT)
      MYBUTTON[pos].Style.RegionColor.MouseOut = #Style.DefaultRegionColor
      State = (State || STATE_DEFAULT)
   Endif
   Dest = win[pos]
   OpenWindow      #<WINDOW>Dest, L, T, W, H, @Nocaption, #<WINDOW>parent, #<STRING>txt, winproc
   SetFont         #<WINDOW>Dest, #Style.FontFace, #Style.FontSize, #Style.FontWeight
   MYBUTTON[pos].hwnd            = win[pos].hwnd
   MYBUTTON[pos].id               = id
   MYBUTTON[pos].W               = W
   MYBUTTON[pos].H               = H
   MYBUTTON[pos].text            = #<STRING>txt
   MYBUTTON[pos].State            = State
   LastRedrawedButton = -2
   xpRedrawButton(id, State)
   Return 1
EndSub
'___________________________________________________________________________________
Sub xpRedrawButton(id:int, NewState:int)
   INT pos, L, T, W, H, BorderColor, _colorHi, _colorLo, RegionColor, FlipColors, ColorTransparent
   POINTER CurrentWindow, ParentWindow, pw
   FlipColors = 0
   Pos = xpGetButtonArrayPosByID(id)
   IF Pos = -1 Then Return
   CurrentWindow = win[pos]
   pw = MYBUTTON[pos].Parent
   ParentWindow = pw
   xpGetColors(RegionColor, BorderColor, pos, NewState)
   Select NewState
      Case STATE_MOUSEOUT
         'remove this
         IF xpPushedButton = id Then setcaption #<WINDOW>ParentWindow, "released"
      Case STATE_PUSHED
         FlipColors = 1 : SetCapture(#<WINDOW>ParentWindow.hwnd)
         'remove this
         setcaption #<WINDOW>ParentWindow, "pushed"
   EndSelect
   xpSetButtonText(0, Null, pos)
   _colorHi = xpColorTwo(RegionColor, 1.1)
   _colorLo = xpColorTwo(RegionColor, 0.86)
   L = 0
   T = 0
   W = MYBUTTON[pos].W
   H = MYBUTTON[pos].H
   IF FlipColors = 1
   _colorHi = xpColorTwo(RegionColor, 0.80)
   _colorLo = xpColorTwo(RegionColor, 1.3)
   Endif
   ColorTransparent = MYBUTTON[pos].Style.ColorTransparent
'   1. Button border outside
   Rect #<WINDOW>CurrentWindow,   0,   0, W, H, BorderColor
   Pset #<WINDOW>CurrentWindow,   0,   0,       ColorTransparent
   Pset #<WINDOW>CurrentWindow, W-1,   0,       ColorTransparent
   Pset #<WINDOW>CurrentWindow,   0, H-1,       ColorTransparent
   Pset #<WINDOW>CurrentWindow, W-1, H-1,       ColorTransparent
'   2. Button border inside
   IF NewState <> STATE_DISABLED
      Rect #<WINDOW>CurrentWindow,   2,   2, W-4, H-4, RegionColor
      Line #<WINDOW>CurrentWindow,   1,   1, W-1,   1, _colorHi
      Line #<WINDOW>CurrentWindow,   1,   2,   1, H-1, _colorHi
      Line #<WINDOW>CurrentWindow,   2, H-2, W-1, H-2, _colorLo
      Line #<WINDOW>CurrentWindow, W-2, H-3, W-2,   1, _colorLo
   Endif
   MYBUTTON[pos].State = NewState
   Return
EndSub
'___________________________________________________________________________________
sub xpGetColors(RegionColor:int byref, BorderColor:int byref, pos:int, state:int)
   INT EventLen, a
   POINTER P, CurrentWindow
   CurrentWindow = win[pos]
   EventLen = len(MYBUTTON[0].Style.BodyColor)
   P  = MYBUTTON[pos].Style.BodyColor
   P += (State * 4)
   a  = #<INT>P
   SetWindowColor #<WINDOW>CurrentWindow, a
   BackPen        #<WINDOW>CurrentWindow, a
   p += EventLen
   FrontPen       #<WINDOW>CurrentWindow, #<INT>P
   p += EventLen
   BorderColor    = #<INT>P
   p += EventLen
   RegionColor    = #<INT>P
' (style)*EventLen : (0)BodyColor / (1)TextColor/ (2)BorderColor / (3)RegionColor
' (0)
   Return
EndSub
'___________________________________________________________________________________
Sub xpRedrawingLogic(/*[ebp+8]*/id:int, /*[ebp+4]*/NewState:int)
   INT pos, x, CurrentButtonState, LastButtonState
   Pos = xpGetButtonArrayPosByID(id)
   CurrentButtonState = MYBUTTON[pos].State
   IF xpPushedButton <> -1
      IF NewState = STATE_MOUSEOUT
         xpRedrawButton(xpPushedButton, STATE_MOUSEOUT)
         IF id = xpPushedButton Then xpRedrawButton(xpPushedButton, STATE_MOUSEOVER)
         LastRedrawedButton = xpPushedButton
         xpPushedButton = -1
         Return
      Endif
   Endif
   IF LastRedrawedButton = id
      IF CurrentButtonState = NewState Then Return
   Endif
   IF CurrentButtonState = STATE_DISABLED Then Return
   x = xpGetButtonArrayPosByID(LastRedrawedButton)
   LastButtonState = MYBUTTON[x].State
   IF LastButtonState = STATE_MOUSEOVER
      xpRedrawButton(LastRedrawedButton, STATE_MOUSEOUT)
   Endif
   'if button was pushed
   IF LastButtonState = STATE_PUSHED
      IF NewState = STATE_MOUSEOVER Then Return
   Endif
   IF NewState = STATE_PUSHED
      xpPushedButton = id
   Endif
   xpRedrawButton(id, NewState)
   LastRedrawedButton = id
   Return
EndSub
'___________________________________________________________________________________
Sub xpSetButtonText(id:int, text:pointer, pos:int)
   INT W, H
   IF pos = -1 Then pos = xpGetButtonArrayPosByID(id)
   IF text <> 0 Then MYBUTTON[pos].text = #<STRING>text
   'center the text
   GetTextSize win[pos], MYBUTTON[pos].text, W, H
   Move  win[pos], (MYBUTTON[pos].W - W) / 2, (MYBUTTON[pos].H - H) /2
   Print win[pos],  MYBUTTON[pos].text
   Return
EndSub
'___________________________________________________________________________________
Sub xpCloseButton(id:int)
   INT a, pos
   POINTER w
   pos = xpGetButtonArrayPosByID(id)
   IF pos = -1 Then Return
   w = win[pos]
   CloseWindow #<WINDOW>w
   'make free place for new buttons
   MYBUTTON[pos].hwnd = 0
   Return
EndSub
'___________________________________________________________________________________
Sub xpCloseAllButtons()
   INT a
   For a = 0 To MaxButtons -1
      IF MYBUTTON[a].hwnd Then CloseWindow win[a]
   Next a
   Return
EndSub
'___________________________________________________________________________________
Sub xpColorTwo(_color:int, procent:float),int
   INT R, G, B
   R = _color & 255
   G = (_color >> 8) & 255
   B = (_color >> 16) & 255
   R *= procent : IF R > 255 Then R = 255
   G *= procent : IF G > 255 Then G = 255
   B *= procent : IF B > 255 Then B = 255
   Return R | G << 8 | B << 16
EndSub
'___________________________________________________________________________________
Sub xpGetButtonIDbyHandle(hwnd:uint),int
   INT a
   For a = 0 To MaxButtons -1
      IF MYBUTTON[a].hwnd = hwnd Then Return MYBUTTON[a].ID
   Next a
   Return -1
EndSub
'___________________________________________________________________________________
Sub xpGetButtonArrayPosByID(id:int),int
   INT a
   For a = 0 To MaxButtons -1
      IF MYBUTTON[a].id = id and a < MaxButtons Then Return a
   Next a
   Return -1
EndSub
'___________________________________________________________________________________
Sub xpGetFreePlace(),int
   INT a
   For a = 0 To MaxButtons -1
      IF MYBUTTON[a].hwnd = 0 Then Return a
   Next a
   Return -1
EndSub
